import { Prop, SetupContext, VNodeChild, VNodeProps } from 'vue';
import { Hanlder } from '@/type';
export declare const GlobalStoreKey = "GlobalStoreKey";
declare type VueComponentProps<T extends Record<string, any>> = Omit<T, 'slots'> & WithVSlots<T> & VNodeProps;
declare type WithVSlots<T extends Record<string, any>> = 'slots' extends keyof T ? {
    'v-slots'?: Partial<T['slots'] & {
        $stable: boolean;
        default(): VNodeChild;
    }>;
    [name: string]: any;
} : Record<string, any>;
declare type WithSlotTypes<T extends Record<string, any>> = Omit<SetupContext, 'slots'> & {
    slots: Partial<T['slots'] & {
        default(): VNodeChild;
    }>;
};
export declare abstract class VueComponent<T = Record<string, any>> {
    /** 装饰器处理 */
    static handler: Hanlder[];
    /** 是否自定义解析组件 */
    static resolveComponent?: any;
    static __vccOpts__value?: any;
    /** 组件option定义,vue3遇到类组件会从此属性获取组件的option */
    static get __vccOpts(): any;
    /** 是否作为全局store提供外部入口，此时会在 当前app上注入2个方法，用于获取此组件的服务 */
    static globalStore?: boolean;
    /** 是否把自己当做服务provide出去，以便子组件可注入 */
    static ProviderKey?: string | symbol;
    /** 主要给jsx提示用 */
    get $props(): VueComponentProps<T>;
    /** 组件属性 */
    props: VueComponentProps<T>;
    /** 组件上下文 */
    context: WithSlotTypes<T>;
    constructor();
    /** 渲染函数 */
    abstract render(): VNodeChild;
    abstract render(ctx?: any): VNodeChild;
    abstract render(ctx?: any, cache?: any[]): VNodeChild;
}
export declare type ComponentProps<T extends Record<string, any>> = {
    [U in keyof Omit<T, 'slots'>]-?: Prop<any>;
};
export declare type ComponentSlots<T extends {
    props: any;
}> = T extends {
    props: infer U;
} ? 'v-slots' extends keyof U ? U['v-slots'] : Record<string, unknown> : never;
/** 为了阻止ts把不相关的类也解析到metadata数据中，用这个工具类型包装一下类 */
export declare type ClassType<T> = T;
export {};
